#include "sharedta.h"  

/******************************************************************************

Sample exntesible DLL that demonstrates how to share information such as # of
STRING or NUMERIC values between SQLWindows applications. Using this DLL, one can 
not only pass data from one SW app to another, but later also receive updated
data from another app. DLL uses array mechanism to share # of numeric or string
values. One can also pass window handles between SW applications and manipulate
value related to window handle (e.g. datafield value in a form of another 
application.


Author: Kuntal D. Thakore
Date Created: 4/18/95
Date last Updated: 4/19/95
Version 1.0     

****************************************************************************/  
//Windows DLL startup procedure
int FAR PASCAL _export LibMain(HINSTANCE hInstance, WORD wDataSeg,WORD wHeapSize,
							   LPSTR lpszCmdLine)
{

  if (wHeapSize > 0)
  {
    UnlockData(0);
  }
  
  return 1;
}  //LibMain
/***************************************************************************/
//Windows DLL exit procedure
int FAR PASCAL _export WEP(int nParam)

{
  return 1;
} //WEP  

/***************************************************************************/
//Return value to calling program.  

LPINT FAR PASCAL _export GetNumber()
{

  return (LPINT) nNum; //need casting due to value sent to different program's 
  					   // datas egment from DLL's data segment.
} //GetNumber                   
/***************************************************************************/

BOOL FAR PASCAL _export PutNumber(int nNumber)
{
// Store the value from a program in a DLL's data segment that 
// can be retrieved later by another program.   

 nNum = (int) nNumber;
 return TRUE;
 
} //PutNumber
/***************************************************************************/
//Routine to retrieve data from DLL to Windows progoram.         

BOOL FAR PASCAL _export GetString(LPSTR strValue)
{  
 //DEBUG
 // MessageBox(NULL,strData,"",MB_OK); 

 if (!(lstrcpy(strValue,strData))) 
 {
    return FALSE;
 }
 return TRUE;
 
}                          
 
/***************************************************************************/
// Routrine to store string data from Windows program into static variable

BOOL FAR PASCAL _export PutString(LPSTR strValue)
{    
  //Trying pass more than 256 characters, can't do that. 
  if (sizeof(strValue) > 256)
  {
   return FALSE;
  }   
  //DEBUG
  //MessageBox(NULL,strValue,"",MB_OK); 
  //if string copy fails, return 0
  if (!(lstrcpy((LPSTR) strData, (LPSTR) strValue)))
  {  
    return FALSE;
  }
  
  return TRUE;
}
/***************************************************************************/
// Function to get window handle from Windows program and store it in DLL. 
BOOL FAR PASCAL _export  PutWinHandle(HWND handle)
{          

  if (!handle) //Check that window handle is not NULL.  
  {    
    return FALSE;
  }   //IF 
  
  hWnd = (HWND) handle;  //store it in a DLL global variable  
  
//DEBUG
//  wsprintf(sShowStr,"handle=%d -  hWnd=%d",handle,hWnd);
//  MessageBox(NULL,(LPSTR) sShowStr,"",MB_OK);
  return TRUE;
} //GetWindowHandle  


/***************************************************************************/
//Function to send Window handle to a Window program.
BOOL FAR PASCAL _export  GetWinHandle(LPHWND handle)
{
  if (!hWnd) //Check that window handle in DLL is not NULL.  
  {    
    return 0;
  }   //IF 
  //Why needed? I am not clear. 
  *handle =  hWnd; //Pass Window handle to a program.    
  
//DEBUG
//  wsprintf(sShowStr,"GET: handle=%d -  hWnd=%d",handle,hWnd);
//  MessageBox(NULL,(LPSTR) sShowStr,"",MB_OK);  
  return TRUE;
  
} //GetWindowHandle 
   

/***************************************************************************/ 
//Function to get multiple integer values from calling program's array

 BOOL FAR PASCAL _export PutIntArray(HARRAY hIntArray)
 {
 
  LONG lLowerLimit, lUpperLimit;
  LONG lCurrent; 
  NUMBER nNum;
  int nArrayIntValue;
 
  SalQueryArrayBounds(hIntArray,&lLowerLimit, &lUpperLimit);
//Needed because SalQueryArrayBounds always returns value which is 1 less than 
//actual # of elements in the array.     
  lUpperLimit++;    
  lCurrent = lLowerLimit; 

  while (lCurrent < lUpperLimit)
  { 
      
     SWinArrayGetNumber(hIntArray,lCurrent, &nNum); // Get the current ele. from array 
     SWinCvtNumberToInt( &nNum,&nArrayIntValue); //conver NUMBER to INT 
     nStoreIntValues[lCurrent] = nArrayIntValue; //put the value in DLL int array.
     lCurrent++;
   
  } //while  

// This is needed to initialize rest of the elements in array to 0.
// So that program which calls GET function don't get values that should not
// be received.    
  for (lCurrent = lUpperLimit+1;lCurrent < MAXINT; lCurrent++)
  {
     nStoreIntValues[lCurrent] = 0;
  } //for 
    
  return TRUE;
 }   //PutIntArray
 /***************************************************************************/
 //Function to send multiple string values (in array) to a calling program.      
 BOOL FAR PASCAL _export GetIntArray(HARRAY hIntArray)   
 {
  LONG lLowerLimit, lUpperLimit;   //Upper-Lower limit of an array
  LONG lCurrent;  //current index in an array     
  NUMBER nNum;    // Current NUMBER type value in array
  int nArrayIntValue;  // Use to hold integer value converted from NUMBER value. 
  
  SalQueryArrayBounds(hIntArray,&lLowerLimit, &lUpperLimit);  
//Needed because SalQueryArrayBounds always returns value which is 1 less than 
//actual # of elements in the array.     
  lUpperLimit++;   
  lCurrent = lLowerLimit; 
  while (lCurrent < lUpperLimit)
  { 
      
     nArrayIntValue = nStoreIntValues[lCurrent]; //Get the current value from
     									         //Integer Array
      
     SWinCvtIntToNumber   ( nArrayIntValue, &nNum ); //Convert int to NUMBER
     SWinArrayPutNumber(hIntArray,lCurrent, &nNum);  // Put the NUM. value into
     												 // array 
     lCurrent++;  //increment array index
   
  } //while  
  
  
 return TRUE;
 }   //GetIntArray

   
   
/***************************************************************************/ 
/*Function to get multiple integer values from calling program's array*/
 
 BOOL FAR PASCAL _export PutStrArray(HARRAY hArray)
 {
 
  LONG lLowerLimit, lUpperLimit;
  LONG lCurrent, lLenght; 
  LPSTR  lpStrItem;
  HSTRING hString;  
  char  strTmpString[256];
 
  SalQueryArrayBounds(hArray,&lLowerLimit, &lUpperLimit);       
//Needed because SalQueryArrayBounds always returns value which is 1 less than 
//actual # of elements in the array.     
  lUpperLimit++; 
  lCurrent = lLowerLimit;   
  while (lCurrent < lUpperLimit)
  { 
      
     SWinArrayGetHString(hArray,lCurrent, &hString); // Get HSTRING from an array
     lpStrItem = SWinHStringLock(hString,&lLenght);  // Get a str ptr from HSTRING
     lstrcpy( (LPSTR)strTmpString,lpStrItem);        // copy str value from ptr
     lstrcpy((LPSTR)strStoreStringValues[lCurrent],(LPSTR)strTmpString); 
     SWinHStringUnlock(hString);  //unlock the current HSTRING
     lCurrent++;  //increment index  
  } //while   
   
// This is needed to initialize rest of the elements in string array to NULL.
// So that program which calls GET function don't get values that should not
// be received.    
  for (lCurrent = lUpperLimit+1;lCurrent < MAXNOSTRINGINARRAY; lCurrent++)
  {
     *strStoreStringValues[lCurrent] = NULL;
  } //for 
          
  return TRUE;
 }   //*PutStrArray  
 

 /***************************************************************************/ 
 

 //Function to send multiple string values (in array) to a calling program.   
  
 BOOL FAR PASCAL _export GetStrArray(HARRAY hArray)   
 {
  LONG lLowerLimit, lUpperLimit;
  LONG lCurrent, lLenght; 
  LPSTR  lpStrItem;
  HSTRING hString; 
 
  SalQueryArrayBounds(hArray,&lLowerLimit, &lUpperLimit);  
// Following statement is needed because SalQueryArrayBounds always returns value 
// which is 1 less than actual # of elements in the array.     
  lUpperLimit++;  //Due to bug in the Sal function???
  lCurrent = lLowerLimit;  
// Loop to Fetch data from DLL array into SW program's array  
  while (lCurrent < lUpperLimit)
  {                               
     hString = 0;
     SWinInitLPHSTRINGParam(&hString,128L);
     lpStrItem = SWinHStringLock(hString,&lLenght);  // Get a str ptr from HSTRING
     lstrcpy(lpStrItem,(LPSTR)strStoreStringValues[lCurrent]);
     SWinHStringUnlock(hString);  //unlock the current HSTRING  
     SWinArrayPutHString(hArray,lCurrent, hString); // Get HSTRING from an array 
     lCurrent++;  //increment index 
  } //while 
  
 return TRUE;
 }   //GetStrArray
 


  